#######################################################################
#                                                                     #
#       (c) Copyright 2013                                            #
#       All rights reserved                                           #
#                                                                     #
#       Programs written by Ling Zhong                                #
#       Department of Computer Science                                #
#       New Jersey Institute of Technology                            #
#       University Heights, Newark, NJ 07102, USA                     #
#       In the group of Jason T. L. Wang (NJIT)                       #
#                                                                     #
#	 Permission to use, copy, modify, and distribute this	          #
#	 software and its documentation for any purpose and without       #
#	 fee is hereby granted, provided that this copyright	          #
#	 notice appears in all copies.   Programmer(s) makes no	          #
#	 representations about the suitability of this		              #
#	 software for any purpose.  It is provided "as is" without        #
#	 express or implied warranty.				                      #
#                                                                     #
#######################################################################

$input = "out";
open(IN, $input);
open(OUT, ">outfea");
open(POS, ">outfeasvm");

$ln=0;

while(<IN>){
   chomp;
   $ln++;
   
   if(($ln%3) == 2){
      $seq = $_;
	  #sequence length
	  $ls = length($seq);
	  print OUT "sequence length: $ls\n";
	  print POS "+0 1:$ls ";
	}
   if(($ln%3) == 0){
      
	  #symmetric difference
	  #number of base pairs
	  $nubp = 0;
      for(my $i = 0; $i < $ls; $i++){
          my $c = substr($_, $i, 1);
		  if($c eq '(') {$lp = $i; $nubp++; }
		  if($c eq ')') {$rp = $i; last;}
	    }
	  
	  $sydi = abs(($lp + int(($rp - $lp - 1)/2) + 1) - ($ls - $rp + int(($rp - $lp - 1)/2)));
	  print OUT "symmetric difference: $sydi\n";
	  print OUT "number of base pairs: $nubp\n";
	  print POS "2:$sydi ";
	  print POS "3:$nubp ";
	  
	  #GC content
	  $gc = 0;
	  
	  for(my $i = 0; $i < $ls; $i++){
	     my $c = substr($seq, $i, 1);
		 if(($c eq 'G')||($c eq 'C')){$gc++;}
	    }
	  print OUT "GC content: $gc\n";
	  print POS "4:$gc ";
	  
	  #length basepair ratio
	  $lbr = $nubp / $ls;
	  $lbr = sprintf "%.3f", $lbr;
	  print OUT "length basepair ratio: $lbr\n";
	  print POS "5:$lbr ";
	  
	  #length of central loop
	  $lcl = $rp - $lp - 1;
	  print OUT "length of central loop: $lcl\n";
	  print POS "6:$lcl ";
	  
	  #free energy per nucleotide
	  $mfe = substr($_, $ls+2, 6);
	  $mfe =~ s/^\s+//;
      print OUT "minimum free energy: $mfe\n";
      print POS "7:$mfe ";	  
	  
	  #bulge size
	  #bulge number
	  #tail length	  
	  $lt = 0;
	  $rt = 0;
	  for(my $i = 0; $i < $ls; $i++){
	     my $c = substr($_, $i, 1);
		 if($c eq '.'){$lt++;}
		 else{last;}
	  }
	  	  
	  
	  $bs = 0;
	  @bs = ();
	  $bn = 0;
	  for(my $i = $lt; $i <= $lp; $i++){
	     my $c = substr($_, $i, 1);
		 if($c eq '.'){$bs++;}
		 if($c ne '.'){
		    push (@bs, $bs);
		    $bs = 0;
		  }
	    }
		
	  for(my $i = $rp; $i < $ls; $i++){
	     my $c = substr($_, $i, 1);
		 if($c eq '.'){$bs++;}
		 if($c ne '.'){
		    push (@bs, $bs);
		    $bs = 0;
		  }
	    }
	  
      $rt = $bs;
      $bs = 0;	  
	  @bs = sort(@bs);
	  foreach $bsa(@bs){
	     if($bsa > 0){$bn++;}
		 if($bsa > $bs){$bs = $bsa;}
	    }
	  
	  if($lt > $rt) {$tl = $lt;}
	  else {$tl = $rt;}
	  print OUT "bulge size: $bs\n";
	  print OUT "bulge number: $bn\n";
	  print OUT "tail length: $tl\n";
	  print POS "8:$bs ";
	  print POS "9:$bn ";
	  print POS "10:$tl ";
	  
	  #number of tails
	  $not = 0;
	  if($lt > 0) {$not++;}
	  if($rt > 0) {$not++;}
	  print OUT "number of tails: $not\n";
	  print POS "11:$not ";
	  
	  #symmetric difference + tail length
	  $sdtl = $sydi + $tl;
	  print OUT "symmetric difference + tail length: $sdtl\n";
	  print POS "12:$sdtl ";
	  
	  #length of central loop + tails
	  $lclt = $lcl + $tl;
	  print OUT "length of central loop + tail length: $lclt\n";
	  print POS "13:$lclt ";
	  
	  #bulge size + length of central loop
	  $bslcl = $bs + $lcl;
	  print OUT "bulge size + length of central loop: $bslcl\n";
	  print POS "14:$bslcl ";
	  
	  #length tail ratio
	  $ltr = $tl / $ls;
	  $ltr = sprintf "%.3f", $ltr;
	  print OUT "length tail ratio: $ltr\n";
	  print POS "15:$ltr ";
	  
	  #length central loop ratio
	  $lclr = $lcl / $ls;
	  $lclr = sprintf "%.3f", $lclr;
	  print OUT "length central loop ratio: $lclr\n";
	  print POS "16:$lclr ";
	  
	  #length bulge size ratio
	  $lbsr = $bs / $ls;
	  $lbsr = sprintf "%.3f", $lbsr;
	  print OUT "length bulge size ratio: $lbsr\n";
	  print POS "17:$lbsr ";
	  
	  #bulge base pair ratio
	  $bbpr = $bs / $nubp;
	  $bbpr = sprintf "%.3f", $bbpr;
	  print OUT "bulge base pair ratio: $bbpr\n";
	  print POS "18:$bbpr ";
	  
	  #A...
	  #A..(
	  #A.(.
	  #A(..
	  #A.((
	  #A(.(
	  #A((.
	  #A(((
	  #C
	  #C..(
	  #C.(.
	  #C(..
	  #C.((
	  #C(.(
	  #C((.
	  #C(((
	  #G
	  #G..(
	  #G.(.
	  #G(..
	  #G.((
	  #G(.(
	  #G((.
	  #G(((
	  #U
	  #U..(
	  #U.(.
	  #U(..
	  #U.((
	  #U(.(
	  #U((.
	  #U(((
	  
	  $addd = 0; $addp = 0; $adpd = 0; $apdd = 0; $adpp = 0; $apdp = 0; $appd =0; $appp = 0;
	  $cddd = 0; $cddp = 0; $cdpd = 0; $cpdd = 0; $cdpp = 0; $cpdp = 0; $cppd =0; $cppp = 0;
	  $gddd = 0; $gddp = 0; $gdpd = 0; $gpdd = 0; $gdpp = 0; $gpdp = 0; $gppd =0; $gppp = 0;
	  $uddd = 0; $uddp = 0; $udpd = 0; $updd = 0; $udpp = 0; $updp = 0; $uppd =0; $uppp = 0;
	  
	  for(my $i = 1; $i < $ls-1; $i++){
	      my $n = substr($seq, $i, 1);
          my $c = substr($_, $i-1, 3);
		    if($c eq "...") {
		       if($n eq 'A'){$addd++;}
			   if($n eq 'C'){$cddd++;}
			   if($n eq 'G'){$gddd++;}
			   if($n eq 'U'){$uddd++;}
		    }
			if($c eq "..(") {
		       if($n eq 'A'){$addp++;}
			   if($n eq 'C'){$cddp++;}
			   if($n eq 'G'){$gddp++;}
			   if($n eq 'U'){$uddp++;}
		    }
			if($c eq ".(.") {
		       if($n eq 'A'){$adpd++;}
			   if($n eq 'C'){$cdpd++;}
			   if($n eq 'G'){$gdpd++;}
			   if($n eq 'U'){$udpd++;}
		    }
			if($c eq "(..") {
		       if($n eq 'A'){$apdd++;}
			   if($n eq 'C'){$cpdd++;}
			   if($n eq 'G'){$gpdd++;}
			   if($n eq 'U'){$updd++;}
		    }
			if($c eq ".((") {
		       if($n eq 'A'){$adpp++;}
			   if($n eq 'C'){$cdpp++;}
			   if($n eq 'G'){$gdpp++;}
			   if($n eq 'U'){$udpp++;}
		    }
			if($c eq "(.(") {
		       if($n eq 'A'){$apdp++;}
			   if($n eq 'C'){$cpdp++;}
			   if($n eq 'G'){$gpdp++;}
			   if($n eq 'U'){$updp++;}
		    }
			if($c eq "((.") {
		       if($n eq 'A'){$appd++;}
			   if($n eq 'C'){$cppd++;}
			   if($n eq 'G'){$gppd++;}
			   if($n eq 'U'){$uppd++;}
		    }
			if($c eq "(((") {
		       if($n eq 'A'){$appp++;}
			   if($n eq 'C'){$cppp++;}
			   if($n eq 'G'){$gppp++;}
			   if($n eq 'U'){$uppp++;}
		    }
		  
		}  
		
		print POS "19:$addd ";
		print POS "20:$addp ";
		print POS "21:$adpd ";
		print POS "22:$apdd ";
		print POS "23:$adpp ";
		print POS "24:$apdp ";
		print POS "25:$appd ";
		print POS "26:$appp ";
		print POS "27:$cddd ";
		print POS "28:$cddp ";
		print POS "29:$cdpd ";
		print POS "30:$cpdd ";
		print POS "31:$cdpp ";
		print POS "32:$cpdp ";
		print POS "33:$cppd ";
		print POS "34:$cppp ";
		print POS "35:$gddd ";
		print POS "36:$gddp ";
		print POS "37:$gdpd ";
		print POS "38:$gpdd ";
		print POS "39:$gdpp ";
		print POS "40:$gpdp ";
		print POS "41:$gppd ";
		print POS "42:$gppp ";
		print POS "43:$uddd ";
		print POS "44:$uddp ";
		print POS "45:$udpd ";
		print POS "46:$updd ";
		print POS "47:$udpp ";
		print POS "48:$updp ";
		print POS "49:$uppd ";
		print POS "50:$uppp ";
		
		print OUT "A...: $addd\n";
		print OUT "A..(: $addp\n";
		print OUT "A.(.: $adpd\n";
		print OUT "A(..: $apdd\n";
		print OUT "A.((: $adpp\n";
		print OUT "A(.(: $apdp\n";
		print OUT "A((.: $appd\n";
		print OUT "A(((: $appp\n";
		print OUT "C...: $cddd\n";
		print OUT "C..(: $cddp\n";
		print OUT "C.(.: $cdpd\n";
		print OUT "C(..: $cpdd\n";
		print OUT "C.((: $cdpp\n";
		print OUT "C(.(: $cpdp\n";
		print OUT "C((.: $cppd\n";
		print OUT "C(((: $cppp\n";
		print OUT "G...: $gddd\n";
		print OUT "G..(: $gddp\n";
		print OUT "G.(.: $gdpd\n";
		print OUT "G(..: $gpdd\n";
		print OUT "G.((: $gdpp\n";
		print OUT "G(.(: $gpdp\n";
		print OUT "G((.: $gppd\n";
		print OUT "G(((: $gppp\n";
		print OUT "U...: $uddd\n";
		print OUT "U..(: $uddp\n";
		print OUT "U.(.: $udpd\n";
		print OUT "U(..: $updd\n";
		print OUT "U.((: $udpp\n";
		print OUT "U(.(: $updp\n";
		print OUT "U((.: $uppd\n";
		print OUT "U(((: $uppp\n";
		
	  #P-value
	##entire stem loop structure
	  #number of nucleotides on symmetrical loops
	  #number of nucleotides on asymmetrical loops
	  #average distance between internal loops
	  #average size of symmetrical loops
	  #average size of asymmetrical loops
	  
	  @bl = ();
	  @br = ();
	  $nusl = 0;
	  $nual = 0;
	  $nsl = 0;
	  $nal = 0;
	  for(my $i = 0; $i < $ls; $i++){
	        my $c = substr($_, $i, 1);
		    if($c eq '('){push(@bl, $i);}
			elsif($c eq ')'){push(@br, $i);}
		}
	  for(my $i = 0; $i < $nubp - 1; $i++){
	        my $dl = $bl[$i+1] - $bl[$i];
	        my $dr = $br[-($i+1)] - $br[-($i+2)];
			if(($dl > 1) || ($dr > 1)){
			      if($dl == $dr) {
				      $nusl = $nusl + $dl + $dr - 2;
					  $nsl++;
				    }
				  else {
				      $nual = $nual + $dl + $dr - 2;
					  $nal++;
					}
			}
		}
		$bpnd = 0;
		for(my $i = $lt; $i < $ls; $i++){
	        my $c = substr($_, $i, 1);
		    if($c eq '('){$bpnd++;}
			elsif($c eq '.'){last;}
		}
		for(my $i = $ls - $rt - 1; $i > 0; $i--){
	        my $c = substr($_, $i, 1);
		    if($c eq ')'){$bpnd++;}
			elsif($c eq '.'){last;}
		}
		$adil = ($nubp * 2 - $bpnd) / ($nsl + $nal + 1);
	    $adil = sprintf "%.3f", $adil;
		if($nsl > 0){$assl = $nusl / $nsl;
		$assl = sprintf "%.3f", $assl;}
		if($nal > 0) {$asal = $nual / $nal;
		$asal = sprintf "%.3f", $asal;}
		print OUT "number of nucleotides on symmetrical loops: $nusl\n";
	    print OUT "number of nucleotides on asymmetrical loops: $nual\n";
		print OUT "average distance between internal loops: $adil\n";
		print OUT "average size of symmetrical loops: $assl\n";
		print OUT "average size of asymmetrical loops: $asal\n";

        print POS "51:$nusl ";
	    print POS "52:$nual ";
		print POS "53:$adil ";
		print POS "54:$assl ";
		print POS "55:$asal ";		
		
	  #proportion of A in stem
	  #proportion of C in stem
	  #proportion of G in stem
	  #proportion of U in stem
	  #proportion of A-U basepairs in stem
	  #proportion of C-G basepairs in stem
	  #proportion of G-U basepairs in stem
	  $ais = 0;
	  $cis = 0;
	  $gis = 0;
	  $uis = 0;
	  $bpau = 0;
	  $bpcg = 0;
	  $bpgu = 0;
	  for(my $i = 0; $i < $nubp; $i++){
	        my $bpl = substr($seq, $bl[$i], 1);
		    my $bpr = substr($seq, $br[-($i+1)], 1);
			if((($bpl.$bpr) eq "AU") || (($bpl.$bpr) eq "UA")){$bpau++; $ais++; $uis++;}
		    if((($bpl.$bpr) eq "CG") || (($bpl.$bpr) eq "GC")){$bpcg++; $cis++; $gis++;}
			if((($bpl.$bpr) eq "GU") || (($bpl.$bpr) eq "UG")){$bpgu++; $gis++; $uis++;}
		}  
	  $pais = $ais / ($nubp * 2);
	  $pais = sprintf "%.3f", $pais;
	  $pcis = $cis / ($nubp * 2);
	  $pcis = sprintf "%.3f", $pcis;
	  $pgis = $gis / ($nubp * 2);
	  $pgis = sprintf "%.3f", $pgis;
	  $puis = $uis / ($nubp * 2);
	  $puis = sprintf "%.3f", $puis;
	  $paub = $bpau / $nubp;
	  $paub = sprintf "%.3f", $paub;
	  $pcgb = $bpcg / $nubp;
	  $pcgb = sprintf "%.3f", $pcgb;
	  $pgub = $bpgu / $nubp;
	  $pgub = sprintf "%.3f", $pgub;
	  
	  print OUT "proportion of A in stem: $pais\n"; 
	  print OUT "proportion of C in stem: $pcis\n";
	  print OUT "proportion of G in stem: $pgis\n";
	  print OUT "proportion of U in stem: $puis\n";
	  print OUT "proportion of A-U basepairs in stem: $paub\n";
	  print OUT "proportion of C-G basepairs in stem: $pcgb\n";
	  print OUT "proportion of G-U basepairs in stem: $pgub\n";
	  
	  print POS "56:$pais "; 
	  print POS "57:$pcis ";
	  print POS "58:$pgis ";
	  print POS "59:$puis ";
	  print POS "60:$paub ";
	  print POS "61:$pcgb ";
	  print POS "62:$pgub ";
	  
	##longest symmetrical region of the stem loop
	  #length
	  #distance from the hairpin loop
	  #number of nucleotides involved in internal loops
	  #proportion of A
	  #proportion of C
	  #proportion of G
	  #proportion of U 
	  #proportion of A-U 
	  #proportion of C-G
	  #proportion of G-U
	  $lsrp = 0;
	  $alsr = 0;
	  $clsr = 0;
	  $glsr = 0;
	  $ulsr = 0;
	  $nblsr = 0;
	  for(my $i = 0; $i < $nubp; $i++){
	        my $dl = $bl[-($i+1)] + ($lp - $bl[-($i+1)]) * 2 + $lcl + 1;
			my $dr = $br[$i];
			if($dl == $dr) {$lsrp = $bl[-($i + 1)]; $nblsr++;}
			else{last;}
		}
	  
	  $lsr = ($lp - $lsrp + 1) * 2 + $lcl;
	  $dfhl = $lp - $lsrp + 1;
	  $nuiil = $lsr - $nblsr * 2;
	  
		
	  $aulsr = 0;
	  $cglsr = 0;
	  $gulsr = 0;
	  
	  for(my $i = $lsrp; $i < $dfhl + $lsrp; $i++){
	        my $sl = substr($seq, $i, 1);
			my $cl = substr($_, $i, 1);
			my $sr = substr($seq, $i + $lcl + ($lp - $i) * 2 + 1, 1);
			my $cr = substr($_, $i + $lcl + ($lp - $i) * 2 + 1, 1);
			if(($cl eq '(') && ($cr eq ')')){
			  if((($sl.$sr) eq "AU") || (($sl.$sr) eq "UA")){$aulsr++; $alsr++; $ulsr++}
		      if((($sl.$sr) eq "CG") || (($sl.$sr) eq "GC")){$cglsr++; $clsr++; $glsr++}
			  if((($sl.$sr) eq "GU") || (($sl.$sr) eq "UG")){$gulsr++; $glsr++; $ulsr++}
			}
		}
	  $palsr = $alsr / ($nblsr * 2);
	  $palsr = sprintf "%.3f", $palsr;
	  $pclsr = $clsr / ($nblsr * 2);
	  $pclsr = sprintf "%.3f", $pclsr;
	  $pglsr = $glsr / ($nblsr * 2);
	  $pglsr = sprintf "%.3f", $pglsr;
	  $pulsr = $ulsr / ($nblsr * 2);
	  $pulsr = sprintf "%.3f", $pulsr;
	  $paulsr = $aulsr / $nblsr;
	  $paulsr = sprintf "%.3f", $paulsr;
	  $pcglsr = $cglsr / $nblsr;
	  $pcglsr = sprintf "%.3f", $pcglsr;
	  $pgulsr = $gulsr / $nblsr;
	  $pgulsr = sprintf "%.3f", $pgulsr;
	  
	  print OUT "length of longest symmetrical region of the stem loop: $lsr\n";
	  print OUT "distance from the hairpin loop: $dfhl\n";
	  print OUT "number of nucleotides involved in internal loops: $nuiil\n";
	  print OUT "proportion of A in stem: $palsr\n"; 
	  print OUT "proportion of C in stem: $pclsr\n";
	  print OUT "proportion of G in stem: $pglsr\n";
	  print OUT "proportion of U in stem: $pulsr\n";
	  print OUT "proportion of A-U basepairs in stem: $paulsr\n";
	  print OUT "proportion of C-G basepairs in stem: $pcglsr\n";
	  print OUT "proportion of G-U basepairs in stem: $pgulsr\n";
	  
	  print POS "63:$lsr ";
	  print POS "64:$dfhl ";
	  print POS "65:$nuiil ";
	  print POS "66:$palsr "; 
	  print POS "67:$pclsr ";
	  print POS "68:$pglsr ";
	  print POS "69:$pulsr ";
	  print POS "70:$paulsr ";
	  print POS "71:$pcglsr ";
	  print POS "72:$pgulsr ";
	  
	  #conservation score
	  #Z-score
	  #100*MFE/length
	  $mlr = $mfe * 100 / $ls;
	  $mlr = sprintf "%.3f",$mlr;
	  print OUT "100*MFE/length: $mlr\n";
	  print POS "73:$mlr ";
	  #ratio of ajusted MFE and the GC content
	  $ramgc = $mlr / $gc;
	  $ramgc = sprintf "%.3f", $ramgc;
	  print OUT "ratio of ajusted MFE and the GC content: $ramgc\n";
	  print POS "74:$ramgc\n";
	}
}

close(IN);
close(OUT);
close(POS);