#######################################################################
#                                                                     #
#       (c) Copyright 2013                                            #
#       All rights reserved                                           #
#                                                                     #
#       Programs written by Ling Zhong                                #
#       Department of Computer Science                                #
#       New Jersey Institute of Technology                            #
#       University Heights, Newark, NJ 07102, USA                     #
#       In the group of Jason T. L. Wang (NJIT)                       #
#                                                                     #
#	 Permission to use, copy, modify, and distribute this	          #
#	 software and its documentation for any purpose and without       #
#	 fee is hereby granted, provided that this copyright	          #
#	 notice appears in all copies.   Programmer(s) makes no	          #
#	 representations about the suitability of this		              #
#	 software for any purpose.  It is provided "as is" without        #
#	 express or implied warranty.				                      #
#                                                                     #
#######################################################################

$species = $ARGV[0];
system("ViennaRNA/bin/RNAfold <inseq> out");
open(OUT, "out");
open(OUTFILE, ">outfile");
while(<OUT>){
   chomp;
   print "\n".$_;
   print OUTFILE "\n".$_;
}
print "\n\n";
print OUTFILE "\n\n";
close OUT;
				
open(SEQ, "out");
$ln = 0;
while(<SEQ>){
   chomp; 
   $ln++;
   $lp = 0;
   $rp = 1000;
   if($ln == 2){$l = length($_);}
   if($ln == 3){
	   for(my $i=0; $i<$l; $i++){
		   $c = substr($_, $i, 1);
		   if($c eq ')'){$rp = $i;}
		   elsif($c eq '('){$lp = $i;}
		   if($lp > $rp) {
				print "\nThe input sequence is not a pre-miRNA because its secondary structure has multiple hairpin loops."; 
				print OUTFILE "\nThe input sequence is not a pre-miRNA because its secondary structure has multiple hairpin loops."; 
				last;
			}
		}
		if(($lp == 0) && ($rp == 1000)){
			print "\nThe input sequence is not a pre-miRNA."; 
			print OUTFILE "\nThe input sequence is not a pre-miRNA.";
		}
	}
}
close SEQ;
if(($lp < $rp) && ($lp > 0)){
	system("perl feature.pl");
	system("rm out");
	
	if($species eq "at"){$fn = 1;}
	elsif($species eq "cb"){$fn = 6;}
	elsif($species eq "ce"){$fn = 1;}
	elsif($species eq "cf"){$fn = 1;}
	elsif($species eq "ci"){$fn = 7;}
	elsif($species eq "dr"){$fn = 11;}
	elsif($species eq "dm"){$fn = 3;}
	elsif($species eq "dp"){$fn = 4;}
	elsif($species eq "eb"){$fn = 5;}
	elsif($species eq "gg"){$fn = 3;}
	elsif($species eq "hs"){$fn = 1;}
	elsif($species eq "mm"){$fn = 1;}
	elsif($species eq "mt"){$fn = 1;}
	elsif($species eq "mu"){$fn = 3;}
	elsif($species eq "os"){$fn = 3;}
	elsif($species eq "pp"){$fn = 1;}
	elsif($species eq "pt"){$fn = 1;}
	elsif($species eq "pr"){$fn = 1;}
	elsif($species eq "rn"){$fn = 10;}
	elsif($species eq "sm"){$fn = 32;}
	elsif($species eq "tg"){$fn = 5;}
	for(my $i = 0; $i < $fn; $i++){
			system("perl selectfeatable.pl $i $i $species");
	}
	system("perl runsvm.pl $species $fn");
	
	print "Number of feature set(s) generated by the feature mining algorithm: $fn";
	print "\nNumber of features in the feature set(s) respectively: ";
	
	print OUTFILE "Number of feature set(s) generated by the feature mining algorithm: $fn";
	print OUTFILE "\nNumber of features in the feature set(s) respectively: ";
	
	
	for(my $i = 0; $i < $fn; $i++){
		my $line_number = 0;
		open(FN, "model/$species/f$i");
		while(<FN>){
		  $line_number++;
		}
		close FN;
		print "$line_number";
		print OUTFILE "$line_number";
		if($i!= ($fn-1)){
		  print ", ";
		  print OUTFILE ", ";
		}
	}
	
	print "\nFinal value produced by the strong classifier through boosting: ";
	print OUTFILE "\nFinal value produced by the strong classifier through boosting: ";
	
	open(H, "h");
	my $h = <H>;
	print $h;
	print OUTFILE $h;
	close H;
	
	
	open(IN, "result");
	while(<IN>){
		chomp;
		print "\n".$_;
		print OUTFILE "\n".$_;
	}
	close IN;
	
	system("rm result");
	system("rm h");
	system("rm outfea");
	system("rm inseq");
	
}

close OUTFILE;


